﻿using System.Drawing;

namespace LegoPixelSpaceInvaders
{
    public class Projectile
    {
        private Point m_Position;
        private bool m_Idle;
        private bool m_PlaySound;

        public bool Idle { get { return m_Idle; } set { m_Idle = value; } }

        public Point Position
        {
            get
            {
                if (m_Idle)
                    return new Point(-10, -10);

                return m_Position;
            }
            set
            {
                if (m_Idle)
                {
                    m_Position = value;
                    m_Idle = false;
                    m_PlaySound = true;
                }
            }
        }

        public Projectile()
        {
            m_Idle = true;
        }

        public void Update(IAudioContext context)
        {
            if (m_PlaySound)
            {
                float balance = Position.X / 113.0f;
                balance *= 200;
                balance -= 100;

                context.PlaySound("piuh", (int)balance);
                m_PlaySound = false;
            }

            if(!m_Idle)
                m_Position.Y -= 5;

            if (m_Position.Y < -3)
                m_Idle = true;
        }

        public void Draw(IDrawingContext context)
        {
            if (!m_Idle)
            {
                Color color = Color.White;
                context.DrawPixel(m_Position.X, m_Position.Y, color);
                context.DrawPixel(m_Position.X, m_Position.Y + 1, color);
                context.DrawPixel(m_Position.X, m_Position.Y + 2, color);
            }
        }
    }
}
